// By ROOT version 5.17/02 on 2008-03-13 06:46:41

#ifndef ROOT_TGDockableFrame
#include "TGDockableFrame.h"
#endif
#ifndef ROOT_TGMenu
#include "TGMenu.h"
#endif
#ifndef ROOT_TGMdiDecorFrame
#include "TGMdiDecorFrame.h"
#endif
#ifndef ROOT_TG3DLine
#include "TG3DLine.h"
#endif
#ifndef ROOT_TGMdiFrame
#include "TGMdiFrame.h"
#endif
#ifndef ROOT_TGMdiMainFrame
#include "TGMdiMainFrame.h"
#endif
#ifndef ROOT_TGuiBldHintsButton
#include "TGuiBldHintsButton.h"
#endif
#ifndef ROOT_TGMdiMenu
#include "TGMdiMenu.h"
#endif
#ifndef ROOT_TGListBox
#include "TGListBox.h"
#endif
#ifndef ROOT_TGNumberEntry
#include "TGNumberEntry.h"
#endif
#ifndef ROOT_TGScrollBar
#include "TGScrollBar.h"
#endif
#ifndef ROOT_TGuiBldHintsEditor
#include "TGuiBldHintsEditor.h"
#endif
#ifndef ROOT_TRootBrowser
#include "TRootBrowser.h"
#endif
#ifndef ROOT_TGFrame
#include "TGFrame.h"
#endif
#ifndef ROOT_TGFileDialog
#include "TGFileDialog.h"
#endif
#ifndef ROOT_TGShutter
#include "TGShutter.h"
#endif
#ifndef ROOT_TGButtonGroup
#include "TGButtonGroup.h"
#endif
#ifndef ROOT_TGCanvas
#include "TGCanvas.h"
#endif
#ifndef ROOT_TGFSContainer
#include "TGFSContainer.h"
#endif
#ifndef ROOT_TGButton
#include "TGButton.h"
#endif
#ifndef ROOT_TGuiBldEditor
#include "TGuiBldEditor.h"
#endif
#ifndef ROOT_TGTextEdit
#include "TGTextEdit.h"
#endif
#ifndef ROOT_TGFSComboBox
#include "TGFSComboBox.h"
#endif
#ifndef ROOT_TGLabel
#include "TGLabel.h"
#endif
#ifndef ROOT_TGView
#include "TGView.h"
#endif
#ifndef ROOT_TRootGuiBuilder
#include "TRootGuiBuilder.h"
#endif
#ifndef ROOT_TGTab
#include "TGTab.h"
#endif
#ifndef ROOT_TGListView
#include "TGListView.h"
#endif
#ifndef ROOT_TGSplitter
#include "TGSplitter.h"
#endif
#ifndef ROOT_TGStatusBar
#include "TGStatusBar.h"
#endif
#ifndef ROOT_TGListTree
#include "TGListTree.h"
#endif
#ifndef ROOT_TGToolTip
#include "TGToolTip.h"
#endif
#ifndef ROOT_TGToolBar
#include "TGToolBar.h"
#endif
#ifndef ROOT_TRootEmbeddedCanvas
#include "TRootEmbeddedCanvas.h"
#endif
#ifndef ROOT_TCanvas
#include "TCanvas.h"
#endif
#ifndef ROOT_TGuiBldDragManager
#include "TGuiBldDragManager.h"
#endif

#include "Riostream.h"
//#include "TThread.h"
#include "TSystem.h"
#include "TApplication.h"
#include "TROOT.h"
#include "TGraph.h"
#include "TH1F.h"
#include "daq.h"
#include "gui.h"

TGTextButton   *gTextButton[10];
TCanvas        *fCanvas;
TGMainFrame    *fMain;
TGTextEntry    *gFilename;
TGNumberEntry  *gCh;
TGNumberEntry  *gMaxEve;
TGNumberEntry  *gNeve;
TGTextEntry    *gTimeDisplay;
TGCheckButton  *gCheckButton;
//TTimer * tmr;
 
TRootEmbeddedCanvas *gCanvas;
#define MAXCH 32
TH1F* gHisto[MAXCH];
daq * gDaq;
#define WINDOW_NAME "Praktikum IV MAPMT PET"
//----------------------------------------------------
int UIRDimming(int state){
  switch (state) {
  case 0:
    gTextButton[0]->SetEnabled(0);
    gTextButton[1]->SetEnabled(1);
    gTextButton[2]->SetEnabled(0);
    
    break;

  case 1:
    gTextButton[0]->SetEnabled(0);
    gTextButton[1]->SetEnabled(0);
    gTextButton[2]->SetEnabled(1);
      
    break;

  case 2:
    gTextButton[0]->SetEnabled(1);
    gTextButton[1]->SetEnabled(1);
    gTextButton[2]->SetEnabled(0);   
    break;

  default:
    break;
  }
  return 0;
}

int fDebug;
void GetDebug(){
  if ( gCheckButton->IsOn() ) fDebug=1;
  else fDebug=0;
}

int GetTime(char *x){
   time_t rawtime;
    struct tm * timeinfo;
    time ( &rawtime );
    timeinfo = localtime ( &rawtime );    
    sprintf(x,"%s",asctime (timeinfo));
    int len=strlen(x);
    if (len) x[len-1]=0;
    return 0;
}

int MyTimer(){
    char cmd[100];
    GetTime(cmd);
    if (gTimeDisplay) gTimeDisplay->SetText(cmd);
    /* Canvas ni thread safe */
    if (gCanvas){
       gCanvas->GetCanvas()->Modified();
       gCanvas->GetCanvas()->Update();
    }
    /*  */
    return 0;
}

//----------------------------------------------------
// thread function 
int gStop=0;
#define BSIZE 10000
unsigned int gBuf[BSIZE];
void *Run(void *ptr)
{
  printf("Start of Run %x \n" ,(int)ptr);

  // odpremo datoteko za pisanje
  char fname[128];
  sprintf(fname,"%s.dat",gFilename->GetText());
  FILE *fp=fopen(fname,"w");
  if (!fp) {
    printf("FILE %s cannot be opened for writing!",fname);
  }
  int neve  = (int) gMaxEve->GetNumber();
  int hdr[4]={1};
  
  if (gDaq) {
    gDaq->fStop=0;
    // zajem zeljenega kolicine podatkov
    gDaq->start();
    for (int n=0;n<neve && !gDaq->fStop ;n++){
      int nb = gDaq->event(gBuf,BSIZE);
      if (nb<=0) n--;

      // zapis v datoteko   
      
      hdr[1]=(8+4)*sizeof(int);
      int nc=0;
      
      while (nb>0){
	hdr[2]=time(NULL);
	hdr[3]=n;
	
	int nbw = fwrite(hdr,   sizeof(int),4 , fp); 
	nbw = fwrite(&gBuf[nc],   sizeof(int),8, fp);
	// napolni histograme
	
	for (int i=0;i<8 ;i++){
	  unsigned short adc =   gBuf[i+nc]&0xFFFF;
	  gHisto[i]->Fill(adc);
	}   
	nc+=8;
	nb-=8;
	n++;
      }
      
      MyTimer();
      gNeve->SetNumber(n); 
      if (gSystem->ProcessEvents()) printf("Run Interrupted\n");
    }  

    gDaq->stop();

  }

  fclose(fp);
  printf("End of Run neve=%d\n",neve);
  UIRDimming(2);


 return 0;
}


int save2ascii(){
         if (!gHisto[0]) return 0; 
         char fname[128];
         sprintf(fname,"%s.txt",gFilename->GetText());
 	 FILE *fp= fopen(fname, "w"); 	 
 	 fprintf(fp, "%s\n",WINDOW_NAME); 
         char cmd[128];
         GetTime(cmd);
 	 fprintf(fp, "Shranjeno: %s\n\n", cmd );
 	 fprintf(fp, "Kanal hid=")	;
 	 for (int j=0;j<MAXCH;j++)  fprintf(fp, "%d\t",j);
 	 fprintf(fp, "\n-------------------------------------------------\n");        				 
 	 for (int i=0;i<gHisto[0]->GetNbinsX();i++){
 	   fprintf(fp, "%d\t",i);
 	   for (int j=0;j<MAXCH;j++) fprintf(fp, "%d\t",(int) gHisto[j]->GetBinContent(i+1));
 	   fprintf(fp, "\n");   
 	 }
 	 fclose(fp);
 	 printf("Rezultati meritev so zapisani v datoteki %s\n",fname);
 	 return 0;
 }


void MyEventHandler(int i){

  UIRDimming(i);
  switch (i) {
  case 0: // Init
    gDaq->init();
    break;
  case 1: // Start
    Run((void*)0);
  case 2: // Stop 
    printf("RunStop()\n");
    gROOT->SetInterrupt();
    gDaq->fStop=1;
  case 3: // ReDraw
    gCanvas->GetCanvas()->Modified();
    gCanvas->GetCanvas()->Update();
    break;
  case 4: // Clear
    for (int j=0;j<MAXCH;j++) if (gHisto[j]) gHisto[j]->Reset();
    break;
  case 5: // Save
    save2ascii();
    break;
  case 6: // Print
    gCanvas->GetCanvas()->SaveAs("canvas.pdf");
    break;
  case 7: // exit
    gApplication->Terminate(0);
    break;
  }
 
}

int MyRedraw(){
  unsigned int ch= (unsigned int)(gCh->GetNumber());
  if (ch<MAXCH && gHisto[ch]) {
        gCanvas->GetCanvas()->cd();
	gHisto[ch]->Draw();
        gCanvas->GetCanvas()->Modified();
        gCanvas->GetCanvas()->Update();
  } else {
    if (gCh->GetNumber()>=MAXCH) gCh->SetNumber(MAXCH-1);
    if (gCh->GetNumber()< 0)     gCh->SetNumber(0);
  }
  
  return 0;
}
//----------------------------------------------------

int gui(){

  for (int i=0;i<MAXCH;i++){
    char hname[50];
    if (i<16) sprintf(hname,"ADC Ch. %d;ADC;N",i);
    else      sprintf(hname,"TDC Ch. %d;TDC;N",i-16);
    char hn[50];
    sprintf(hn,"ch%d",i);
    gHisto[i]   = new TH1F(hn,hname,4096,-0.5,4095.5);
  }  
  gDaq= new daq();
  fMain = new TGMainFrame(0,800,800);
  TGHorizontalFrame *fH=new TGHorizontalFrame(fMain,800,400);
  //------------------------------------------------------------
  TGLayoutHints *f0= new TGLayoutHints(kLHintsLeft | kLHintsTop,2,2,2,2);
  TGLayoutHints *layout2= new TGLayoutHints(kLHintsLeft | kLHintsTop,20,20,20,20);
  // gumbi
  
  int nbut=8;
  const char *names[10]={"Inicializacija","Start","Stop","Osvezi","Zbrisi","Shrani v datoteko", "Natisni" , "Izhod"};
  for (int i=0;i<nbut;i++){
    
    gTextButton[i]= new TGTextButton(fH, names[i]);
    gTextButton[i]->SetTextJustify(36);
    gTextButton[i]->SetMargins(0,0,0,0);
    gTextButton[i]->SetWrapLength(-1);
    gTextButton[i]->Resize(50,22);
    fH->AddFrame(gTextButton[i], layout2);
    char cmd[50];

    sprintf(cmd,"MyEventHandler(=%d)",i);


    TQObject::Connect(gTextButton[i],"Clicked()",0,0,cmd);
  }

  gCheckButton =  new TGCheckButton( fH,"Razhroscevanje");
  gCheckButton->Resize(50,22);
  TQObject::Connect(gCheckButton,"Clicked()", 0, 0 , "GetDebug()");
  gCheckButton->SetState(kButtonDown);
  fH->AddFrame(gCheckButton, f0);
 
  fMain->AddFrame(fH    , f0);
  //---------------------------------------------------------
  // ura
  TGLabel *lab1;
  fH=new TGHorizontalFrame(fMain,800,200);
  lab1 = new TGLabel( fH ,"Ura:");
  fH->AddFrame(lab1, f0);
  gTimeDisplay =  new TGTextEntry( fH,"");
  gTimeDisplay->Resize(200,22);
  fH->AddFrame(gTimeDisplay, f0);
  fMain->AddFrame(fH    , f0);
  //---------------------------------------------------------
  // inputi
  fH=new TGHorizontalFrame(fMain,800,200);
  lab1 = new TGLabel( fH ,"Ime datoteke:");
  fH->AddFrame(lab1, f0);
  gFilename =  new TGTextEntry( fH,"datoteka");
  gFilename->Resize(200,22);
  fH->AddFrame(gFilename, f0);
  fMain->AddFrame(fH    , f0);
  //---------------------------------------------------------
  fH=new TGHorizontalFrame(fMain,800,200);
  lab1 = new TGLabel( fH ,"Zeljeno stevilo dogodkov:");
  fH->AddFrame(lab1, f0);
  gMaxEve =  new TGNumberEntry( fH,10000);
  gMaxEve->Resize(100,22);
  fH->AddFrame(gMaxEve, f0);
  fMain->AddFrame(fH    , f0);
  //---------------------------------------------------------
  fH=new TGHorizontalFrame(fMain,800,200);
  lab1 = new TGLabel( fH ,"Zajetih dogodkov:");
  fH->AddFrame(lab1, f0);
  gNeve =  new TGNumberEntry( fH,0);
  gNeve->Resize(100,22);
  fH->AddFrame(gNeve, f0);
  fMain->AddFrame(fH    , f0);
  //---------------------------------------------------------
  // canvas
  fH=new TGHorizontalFrame(fMain,800,200);
  gCanvas = new TRootEmbeddedCanvas ("gCanvas",fH,800,400);
  fH->AddFrame(gCanvas, f0);
  fMain->AddFrame(fH   , f0);
  //------------------------------------------------------------ 
  fH=new TGHorizontalFrame(fMain,800,200);
  lab1 = new TGLabel( fH ,"St. kanala (0..31):");
  fH->AddFrame(lab1, f0);
  gCh =  new TGNumberEntry( fH,2);
  fH->AddFrame(gCh, f0);
  TQObject::Connect(gCh,"ValueSet(Long_t)",0,0,"MyRedraw( )"); 
  
  fMain->AddFrame(fH    , f0);
  //------------------------------------------------------------
  fMain->SetWindowName(WINDOW_NAME);
  fMain->MapSubwindows();
  fMain->Resize(fMain->GetDefaultSize());
  fMain->MapWindow();
  MyRedraw();
  GetDebug();
  return 0;
}
