#include <stdlib.h>
#include <stdio.h>
#include <zlib.h>
#include "TH1F.h"
#include "TCanvas.h"
#include "TStyle.h"

#define MAXCH 10
TH1F* gHisto[MAXCH];
TH1F* gHistoSum[2];

int init(){
  gStyle->SetOptFit(1011);

  for (int i=0;i<MAXCH;i++){
    char hname[50];
    char hn[50];
    sprintf(hname,"ADC Ch. %d;ADC;N",i);
    sprintf(hn,"ach%d",i);
    gHisto[i]   = new TH1F(hn,hname,1200,-0.5,1199.5);
  }  
  gHistoSum[0]= new TH1F("hsum0","hsum0",4200,-0.5,4199.5);
  gHistoSum[1]= new TH1F("hsum1","hsum1",4200,-0.5,4199.5);
  return 0;
}

int readtdcfile(const char *fname){

  const int bsize=10000;
  unsigned int buf[10000];
  int hdr[4];
  gzFile fp;

  fp=gzopen(fname,"rb");
  init();

  if (fp){
    while (!gzeof(fp) ){
      int nitems = gzread(fp,hdr,4*sizeof(int)); 
      if (nitems==4*sizeof(int)){
// napolni histograme
        int nb=hdr[1]-4*sizeof(int);
        if ( nb > bsize) {
          nb=bsize;
          printf ("Error bsize %d nb%d\n",bsize,nb);
        }
	//        int n=hdr[3];
        nitems=gzread(fp,buf,nb);
        int sum[2]={0,0};
        if (nitems==nb){
          for (int i=0;i<MAXCH;i++){
            unsigned short adc=buf[i]&0xFFFF;
            if (i<4) sum[0]+=adc;
              else if (i<8) sum[1]+=adc;
            gHisto[i]->Fill(adc);
          }   
          gHistoSum[0]->Fill(sum[0]);
          gHistoSum[1]->Fill(sum[1]);
        }
      }
    }
  }
  gzclose(fp);
  printf("Konec\n");
  TCanvas *c1=new TCanvas("c1","c1");
c1->Divide(2,2);
  gHistoSum[0]->Draw();
  TCanvas *c2=new TCanvas("c2","c2");
  gHistoSum[1]->Draw();
  c1->Modified();
  c1->Update();
  c2->Modified();
  c2->Update();
  return 0;
}
