#include <stdlib.h>
#include <stdio.h>
#include <zlib.h>
#include "TH1F.h"
#include "TH2F.h" 
#include "TCanvas.h"
#include "TStyle.h"

#define MAXCH 10

TH1F* gHisto[MAXCH];
TH1F* gHistoSum[2];
//TH1F* gHistoXaavg[1];
//TH1F* gHistoYaavg[1];
//TH1F* gHistoXbavg[1];
//TH1F* gHistoYbavg[1];
TH2F* gHistoA[1];
TH2F* gHistoB[1];    

//int xacoordinates[4] = {1, 1, -1, -1};
//int yacoordinates[4] = {-1, 1, -1, 1};
//int xbcoordinates[4] = {-1, -1, 1, 1};
//int ybcoordinates[4] = {-1, 1, -1, 1};

int init(){
  gStyle->SetOptFit(1011);
  gStyle->SetPalette(1,0);    //za TH2F paleta

  for (int i=0;i<MAXCH;i++){
    char hname[50];
    char hn[50];
  
      sprintf(hname,"ADC Ch. %d;ADC;N",i);
      sprintf(hn,"ach%d",i);
   
       gHisto[i]   = new TH1F(hn,hname,1200,-0.5,1199.5);
  }  
    gHistoSum[0]   = new TH1F("hsum0","hsum0",4200,-0.5,4199.5);
    gHistoSum[1]   = new TH1F("hsum1","hsum1",4200,-0.5,4199.5);

   //gHistoXaavg[0]  = new TH1F("Xa","Xa",4200,-0.5,4199.5);
   //gHistoYaavg[0]  = new TH1F("Ya","Ya",4200,-0.5,4199.5);
   //gHistoXbavg[1]  = new TH1F("Xb","Xb",4200,-0.5,4199.5);
   //gHistoYbavg[1]  = new TH1F("Yb","Yb",4200,-0.5,4199.5);

        gHistoA[0]   = new TH2F("Xa","Ya",420,-0.5,5000,420,-0.5,1500);
        gHistoB[1]   = new TH2F("Xb","Yb",420,-0.5,5000,420,-0.5,1500);

 return 0;
}

int readtdcfilemat1(const char *fname)
{
  
 float adca[4],adcb[4];

  const int bsize = 10000;
  unsigned int buf[10000];
  int hdr[4];
	gzFile fp;
	fp=gzopen(fname,"rb");
	init ();
  if (fp){

    while (!gzeof(fp) ){

      int nitems = gzread(fp, hdr, 4*sizeof(int));
 
      if (nitems == 4*sizeof(int)) {
	// napolni histograme
	int nb = hdr[1] - 4*sizeof(int);

	if ( nb > bsize) {
	  nb = bsize;
	  printf ("Error bsize %d nb%d\n",bsize,nb);
	}

	nitems=gzread(fp, buf, nb);
	int sum[2] = {0,0};

	if (nitems == nb) {
	  
	  for (int i=0; i<MAXCH ; i++) {
	    unsigned short adc = buf[i]&0xFFFF;
	    if (i<4) {
              adca[i]=adc;
              sum[0]+=adc;
            }
             else if (i<8) {
              adcb[i-4]=adc;
              sum[1]+=adc;
            }
	    gHisto[i]->Fill(adc);
	  }

	  //gHistoXaavg[0]->Fill((adca[1]+adca[2])-
			       (adca[3]+adca[4])/
			       (adca[1]+adca[2]+
			        adca[3]+adca[4]));

	  //gHistoYaavg[0]->Fill((adca[2]+adca[4])-
			       (adca[1]+adca[3])/
			       (adca[1]+adca[2]+
			        adca[3]+adca[4]));

	  //gHistoXbavg[1]->Fill((adcb[3]+adcb[4])-
			       (adcb[1]+adcb[2])/
			       (adcb[1]+adcb[2]+
			        adcb[3]+adcb[4]));

	  //gHistoYbavg[1]->Fill((adcb[2]+adcb[4])-
			       (adcb[1]+adcb[3])/
			       (adcb[1]+adcb[2]+
			        adcb[3]+adcb[4]));


	  gHistoA[0]->Fill(sum[0]);
	  gHistoB[1]->Fill(sum[1]);
	    
	  }
	}
      }
    }
    gzclose(fp);
    
  }
  printf("Konec\n");
 
  TCanvas *c1=new TCanvas("c1","c1");
  gHisto[1]->Draw();
  TCanvas *c2=new TCanvas("c2","c2");
  gHisto[2]->Draw();
  c1->Modified();
  c1->Update();
  c2->Modified();
  c2->Update();
  return 0;
}
