#include <stdlib.h>
#include <stdio.h>
#include <zlib.h>
#include "TH1F.h"
#include "TCanvas.h"
#include "TStyle.h"
#include "TMath.h"

#define MAXCH 10

TH1F* tempHisto[135];
TH1F* RMSHisto;

double arrxRMS[135];

//definicija spremenljivk Za, Zb, ZA, XA, YA, ZB, XB, YB
  double Za=0;       //začetna dolžina v PMT A
  double Zb=-135;    //končna dolžina v PMT B
  
  double ZA;      //izbereš med PMT A in izvorom (od 0 do cca -51mm)
  double XA;
  double YA;
  
  double ZB;      //izbereš med PMT B in izvorom (od cca -51mm do -135mm)
  double XB;
  double YB;

//definicija spremenljivk Xa, Ya, Xb, Yb
  double Xa;
  double Ya;
  double Xb;
  double Yb;


int init(){
  gStyle->SetOptStat("nemr");
 
  for(int i=0; i<135; i++){
  tempHisto[i]   = new TH1F("temp1", "temp2", 100,-40,40);
  }

       RMSHisto  = new TH1F("RMS, Z", "title", 135,-0.5,134.5);

 return 0;
}

int plot(){
//funkcija za risanje grafa RMS
TCanvas *c7  = new TCanvas("c7","c7",500,500);    //definiram kanvas

    RMSHisto->Draw();

    RMSHisto->GetXaxis()->SetTitle("RMS");    
    RMSHisto->GetYaxis()->SetTitle("Z [mm]");    
    RMSHisto->GetXaxis()->CenterTitle();    
    RMSHisto->GetYaxis()->CenterTitle();    
    //RMSHisto->GetXaxis()->SetTitleOffset(2);    
    //RMSHisto->GetYaxis()->SetTitleOffset(2);  

c7->Modified();
c7->Update();

  return 0;
}

int readtdcfilematRMS(const char *fname){
  
  float adca[4],adcb[4];    //definicija adc-jev iz A in B fotopomnoževalke
  float off0 [8]={132,135,148,142,124,122,150,153};    //izmerjeno pri napetosti 0V


  //definicija koordinat
  double a1[2]={36,-36};     //koordinata A1
  double a2[2]={36,36};      //koordinata A2
  double a3[2]={-36,-36};    //koordinata A3
  double a4[2]={-36,36};     //koordinata A4
  //double a[2];             //koordinata tezisca {0,0}

  double b1[2]={-36,-36};    //koordinata B1
  double b2[2]={-36,36};     //koordinata B2
  double b3[2]={36,-36};     //koordinata B3
  double b4[2]={36,36};      //koordinata B4
  //double b[2];             //koordinata tezisca {0,0}

  const int bsize = 10000;
  unsigned int buf[10000];
  int hdr[4];
	gzFile fp;
	fp=gzopen(fname,"rb");    //odpre datoteko s podatki
	init ();{
  if (fp){

    while (!gzeof(fp) ){

      int nitems = gzread(fp, hdr, 4*sizeof(int));
 
      if (nitems == 4*sizeof(int)) {
	
        // napolni histograme
	int nb = hdr[1] - 4*sizeof(int);

	if ( nb > bsize) {
	  nb = bsize;
	  printf ("Error bsize %d nb%d\n",bsize,nb);
	}

	nitems=gzread(fp, buf, nb);
        int sum[2] = {0,0};

	if (nitems == nb) {
	  
	  for (int i=0; i<MAXCH; i++) {
	    unsigned short adc = buf[i]&0xFFFF;
	    if (i<4) {
              adca[i]=adc - off0[i]; 
              sum[0]+=adc - off0[i];
            }
             else if (i<8) {
              adcb[i-4]=adc - off0[i-4];
              sum[1]+=adc - off0[i-4];
            }
	  }

      
        Xa = ((a1[0]*adca[0]+a2[0]*adca[1]+a3[0]*adca[2]+a4[0]*adca[3])/(sum[0]));    //koordinata Xa
	Ya = ((a1[1]*adca[0]+a2[1]*adca[1]+a3[1]*adca[2]+a4[1]*adca[3])/(sum[0]));    //koordinata Ya
      
       
        Xb = ((b1[0]*adcb[0]+b2[0]*adcb[1]+b3[0]*adcb[2]+b4[0]*adcb[3])/(sum[1]));    //koordinata Xb
	Yb = ((b1[1]*adcb[0]+b2[1]*adcb[1]+b3[1]*adcb[2]+b4[1]*adcb[3])/(sum[1]));    //koordinata Yb
        
        XA = ((((Xb-Xa)/(Zb-Za))*(ZA-Za))+Xa);    //koordinata XA za ravnino
        YA = ((((Yb-Ya)/(Zb-Za))*(ZA-Za))+Ya);    //koordinata YA za ravnino   
        XB = ((((Xb-Xa)/(Zb-Za))*(ZB-Za))+Xa);    //koordinata XB za ravnino
        YB = ((((Yb-Ya)/(Zb-Za))*(ZB-Za))+Ya);    //koordinata YB za ravnino

 
    for (int i=0; i<135; i++){                //XA
     if (sum[0] > 100){
     ZA=-i;
     XA = ((((Xb-Xa)/(Zb-Za))*(ZA-Za))+Xa);
     tempHisto[i]->Fill(XA);
     arrxRMS[i]=tempHisto[i]->GetRMS();
     } 
    }

/*
    for (int i=0; i<135; i++){                //XB
     if (sum[0] > 200){
     ZB=-i;
     XB = ((((Xb-Xa)/(Zb-Za))*(ZB-Za))+Xa);
     tempHisto[i]->Fill(XB);
     arrxRMS[i]=tempHisto[i]->GetRMS(); 
     } 
    }


    for (int i=0; i<135; i++){                //YA
     if (sum[0] > 100){
     ZA=-i;
     YA = ((((Yb-Ya)/(Zb-Za))*(ZA-Za))+Ya);
     tempHisto[i]->Fill(YA);
     arrxRMS[i]=tempHisto[i]->GetRMS(); 
     } 
    }

  
    for (int i=0; i<135; i++){                //YB
     if (sum[0] > 200){
     ZB=-i;
     YB = ((((Yb-Ya)/(Zb-Za))*(ZB-Za))+Ya);
     tempHisto[i]->Fill(YB);
     arrxRMS[i]=tempHisto[i]->GetRMS(); 
     } 
    }
*/
         
	    
	}
      }
    }
  }


    gzclose(fp);
  

for(int i=0; i<135; i++){        //za izpisovanje RMS-jev
printf("%f\n", arrxRMS[i]);
}

                  
for (int i=0; i<135; i++){        //za risanje RMS-jev
RMSHisto->Fill(i,arrxRMS[i]);
}

  }
  printf("Konec\n");
  
  plot();

  return 0;
}
